/*
*  IRC Services
*
*  Copyright (C) 2003 Services Developers
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of version 1 of the GNU General Public License,
*  as published by the Free Software Foundation.
*
*  This program is distributed in the hope that it will be useful, but
*  WITHOUT ANY WARRANTY; without even the warranty of MERCHANTABILITY
*  or FITNESS FOR A PARTICULAR PURPOSE. The GNU General Public License
*  contains more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*  $Id: resv.h,v 1.8 2003/11/25 00:28:22 kllrloop Exp $
*/

#include "irc_types.h"
#include "client.h"

typedef struct reserve
{
  struct reserve *next;
  char *creator; /* Resv creator */
  char *resv;    /* What we are resv'ing */
  char *chan;    /* If it's a chan */
  char *reason;  /* Resv reason */
  u_short type; /* For the case: statements in resv */
  u_int32_t matches;
  time_t created;
}

reserve_t;
typedef struct _reserve_type
{ 
  char *name;
  u_short qtype;
}
reserve_type;

extern reserve_type reserve_types[];
void    	add_reserve     	        (char *, char *, char *, time_t);
int   		del_reserve     		(sock_t *, char *, char *);
reserve_t *     find_reserve    		(char *, char *);
int     	list_reserves   		(sock_t *, char *, u_short type);
int     	resvtop 			(const void *, const void *);
int     	resvbottom      		(const void *, const void *);
void    	del_all_reserves        	(void);

